<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070702;11462700">
	<META NAME="CHANGED" CONTENT="20070710;13172800">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Transform Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P><A HREF="#definition">Definition</A><BR><A HREF="#How to Transform Grammar into CNF|outline">How
to Transform a Context-Free Grammar into CNF</A></P>
<UL>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Remove Lambda Productions|outline">Remove
	Lambda Productions</A></P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Remove Unit Productions|outline">Remove
	Unit Productions</A></P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Remove Useless Productions|outline">Remove
	Useless Productions</A></P>
	<LI><P><A HREF="#Convert to CNF|outline">Convert to CNF</A></P>
</UL>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">The Chomsky Normal Form (CNF) for a
context-free grammar has a restricted format, in that the right-side
of a production has either two variables or one terminal. CNF's
restrictions result in many efficient algorithms, such as improving
speed in Brute Force parsing.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Transform a Context-Free Grammar into CNF</H2>
<P><A NAME="language1"></A>We will begin by loading the grammar in
the file <A HREF="grammarTransform.jff">grammarTransform.jff</A>.
Then click on the <B>Convert</B> menu, then click on <B>Transform
Grammar</B>. Now, there are four steps that we have to go through in
order to transform the grammar into CNF. They are removing lambda,
unit, and useless productions, followed by a final step. Each step
will be discussed in the following sections.</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Remove Lambda Productions|outline"></A>
Remove Lambda Productions</H2>
<P STYLE="margin-bottom: 0in">After clicking <B>Transform Grammar</B>,
JFLAP will open the tab <B>Lambda Removal </B>and you should able to
see a window similar to this.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=479 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The first step is to
identify the variables that can derive a lambda production. It is
fairly obvious to see that the variable “C” can derive lambda via
the production “C-&gt;lambda” as it is a lambda production.
Therefore, we should add the variable “C” to the set of variables
that derive lambda by clicking on any “C” production. After
clicking, your window should look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=479 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now JFLAP tells us that
there is one more variable that we need to identify. Notice that
there is production “A-&gt;C”. Since variable “C” could
derive lambda, it can be concluded that “A-&gt;C” production
could lead to a lambda production. Thus, we click on this production
to add “A” to the set of variables that derive lambda. Your
window should now look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=479 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We have successfully
identified all the variables that can derive lambda. Note that a copy
of the grammar appears on the right-side of the window for us to
modify. Get rid of all lambda productions by clicking on them and
clicking <B>Delete</B>. There is one. Now, we have to add new
productions to make sure that our grammar still accepts/rejects the
same strings as it did before the lambda removal. JFLAP notifies you
to add 6 more productions. A new production(s) must be created for
productions with right-hand sides that contain a variable that could
derive lambda, it could have disappeared before. However, do not add
any lambda productions. You can click on the production on the left
side and click <B>Complete Selected </B>to let JFLAP add new
productions related to that production. You can also manually add all
the productions. For instance, since variable “C” could derive
lambda, we could have derived terminal “c” from variable “C”
(“C-&gt;cC” and derived C-&gt;lambda). However, since we do not
have lambda any more we have to add production “C-&gt;c” into our
grammar. After entering all the productions, your window should look
like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=479 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Since lambda removal is
complete, we can click <B>Proceed </B>and move on to the next step.</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Remove Unit Productions|outline"></A>
<B>Remove Unit Productions</B></H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now it's time to remove unit
productions. Your unit removal window would look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">There is a picture with each
variable from the grammar shown as a node in a graph with no edges.
We will use the graph to see relationships between variables in unit
productions. For each unit production “X-&gt;Y” add a directed
edge(or transition) from node X to Node Y. JFLAP notifies you that
you need to add 2 more transitions to the unit production
visualization. The variable “A” is directly connected to variable
“C” through the production “A-&gt;C”. For the similar reason,
we can connect variable “C” to “B”. After we finish adding
these 2 transitions, our window should look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">A copy of the grammar you
can modify is now shown in the lower right window. First remove the
unit productions by selecting them in the bottom right panel. Select
the production and click <B>DELETE</B>. After the deletion is
complete, we need to add new productions. For unit productions, both
implicit and explicit (such as “A-&gt;B” from “A-&gt;C” and
“C-&gt;B” as shown from the visualization), additional rules must
be added to handle the missing unit productions. We have to make sure
this changed grammar still accepts/rejects the same strings as it did
before. For example, since we removed the production from variable
“A” to variable “C”, we cannot derive terminal “c” from
variable “A”. So, we have to add the production “A-&gt;c”
into our grammar. JFLAP kindly notifies us how many more productions
we have to add. After we finish adding all the productions, we are
finished with unit removal and the window should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_7.png" NAME="Graphic7" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, we click on <B>Proceed
</B>button and move on to the next step.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Remove Useless Productions|outline"></A>
<B>Remove Useless Productions</B></H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After successfully removing
both lambda and unit productions, your grammar window would look like
:</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_8.png" NAME="Graphic8" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">A production is useless if
no derivation can use it. Removing useless productions is a two-step
process. First, find useless variables that cannot derive any string
of terminals and remove productions with those variables. Second,
find variables that are unreachable from the start symbol and remove
productions with those variables. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">As JFLAP indicates, first we
click on variables that derive terminals directly. They are variables
“S”, “A”, “C”, and “F”. Also, if there are
productions with only these variables on the right-side, then the
variable on the left-side can also derive a string of terminals, and
should be added such as “D” from “D-&gt;dF”. Click on
variable “D” to add it. After clicking these variables, your
window should look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_9.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; page-break-before: always"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">There are two new items
shown. A visualization graph and below it, a copy of the grammar is
shown, with rules missing that have variables that could not derive a
string of terminals, productions with the variables “B” and “E”.
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The visualization has a node
for each variable in the remaining grammar. This graph is different
then the graph for removing unit-productions. For this graph, add a
transition from variable “X” to variable “Y” if there is a
production with “X” on the left-side and “Y” anywhere on the
right-side. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, we have to add 5
transitions among these variables. From the production “S-&gt;bAC”,
we know that variable “S” depends on both “A” and “C”. We
also know that “A” depends on “C” based on the production
“A-&gt;cC”. We will add these transitions to our state diagram,
by clicking the arrow in the panel and creating transitions. Add the
remaining transitions. Now your window would look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_10.png" NAME="Graphic10" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We now need to remove rules
with those variables that are not reachable from “S”. That would
be rules with “D” and “F” as those nodes are not reachable
from “S” in the graph. Click on them and then click <B>DELETE</B>.
After eliminating all of the useless productions, your window should
look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_10-1.png" NAME="Graphic10-1" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now we have successfully
removed useless productions. By clicking on the <B>Proceed</B>
button, we will move on to our final step.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to1"></A><A NAME="Convert to CNF|outline"></A>
<B>Convert to CNF</B></H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, we are at the final
step of converting our grammar to CNF. In CNF, the right side of a
production is either one terminal or two variables. If you have done
everything correctly in previous steps, your window should look like
this now : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_11.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that the production
“S-&gt;bAC” does not follow our CNF restriction and it must be
converted. You can convert this production by clicking on the
production on the right panel and click <B>Convert Selected</B>. Now
your JFLAP window will look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_12.png" NAME="Graphic12" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We have replaced the
terminal “b” in “S-&gt;bAC” with a new variable “B(b)”
and a production “B(b)-&gt;b”. The production “S-&gt;B(b)AC”
now has all variables on the right-side, but has too many. Clicking
<B>Convert Selected</B> again expands this production into 2
productions “S-&gt;B(b)D(1)” and “D(1)-&gt;AC” and another
new variable “D(1)”. After following this step, your window
should look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_12-1.png" NAME="Graphic12-1" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">As JFLAP indicates, we have
to convert 4 more productions. Try to select those productions, and
create the missing productions.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Alternatively, click on <B>Do
All</B> to finish the conversion. After we are finished with the
conversion, the grammar will be in CNF. Our final window should look
like below and we can export this grammar to utilize in fast parsing.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_13.png" NAME="Graphic13" ALIGN=MIDDLE WIDTH=806 HEIGHT=684 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Transforming a Grammar. Thanks for reading!</B></P>
</BODY>
</HTML>